#
# spec file for package canna (Version 3.5b2)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  termcap xf86
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext libtool libz pam perl rpm termcap xdevel xf86 xshared

Name:         canna
License:      BSD
Group:        System/I18n/Japanese
Prereq:       /usr/sbin/useradd
BuildPrereq:  termcap
Requires:     cannadic
Autoreqprov:  on
Version:      3.5b2
Release:      761
URL:          http://www.nec.co.jp/japanese/product/computer/soft/canna/
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Summary:      Kana and Kanji Conversion System
Source:       ftp://ftp.nec.co.jp/pub/Canna/Canna35/Canna35b2.tar.bz2
Source1:      candoc.tar.bz2
Source2:      rccanna
Source3:      hosts.canna
Patch:        Canna35b2-unoff1.patch
Patch1:       Canna35b2-unoff2.patch
Patch2:       Canna35b2-hack1.patch
Patch3:       Canna35b2.patch
Patch4:       Canna35b2.suse.diff
Patch5:       Canna35b2.security.diff
Patch6:       Canna35b2.intptr.dif
Patch7:       Canna35b2.config.patch
Patch8:       Canna35b2.canuum.patch
Patch9:       Canna35b2.canuum.suse.patch
Patch10:      Canna35b2.dif
# multibyte patch needed for Nicolatter,
# see http://www2.airnet.ne.jp/pak04955/dl-linux.htm
# Patch can also be found in the nicolatter package
Patch11:      canna-3.5b2-q2.diff
Patch12:      Canna35b2-default-dictionaries.patch
Patch13:      Canna35b2-imakefile.patch
Patch14:      Canna35b2-security-2002-01.patch
# Summary(ja):  Canna - ʴѴƥ
# %description -n canna -l ja
# UNIX Ƕ̤˻ȤܸϥƥȤ Wnn ¸ߤޤ
# ؤʡ٤ UNIX ܸϤȤ Wnn ʳˤ⤦Ĥ
# Ϳ뤳ȤǤФȻפե꡼եȥȤïǤѤǤ
# ˤޤ
# 
# 
# ؤʡ٤ Wnn Ʊ͡ץꥱץȤʴѴ
# 򥢥뤫ʴѴФ̤ΥץȤʬΥ줿
# ȡзư򤷤ޤΤȤޤؤʡ٤ĹȤ
# ưʲޤ
# 
# 
# (1) 饤ȡΤʴѴ
# (2) ༡ưѴΥݡ
# (3) Ūʥ桼󥿥ե
# (4) ϰϤʥޥΥݡ
# (5) lisp ١Υޥ
# (6) ñϿκŬʻŤ
# (7) Ūʥ桼󥿥եñ󶡤뤿Υ饤֥
# (8) ƥʥ󥹤뤿Υޥɷ
# (9) ޥñ˹ԤΥޥġ
# (10) Nemacs(Mule)kinput2uum Υݡ

%description
Canna converts kana to kanji based on a client-server model. That is,
an application program communicates with a kana-to-kanji conversion
server to achieve Japanese input. Canna can be used in Emacs, in X
environments, and also on TTYs. Canna provides more than ten tools to
maintain kana-to-kanji conversion dictionaries.

Authors:
--------
    Osamu Hata <hata@d1.bs2.mt.nec.co.jp>

SuSE series: j


%description -l ja

%package -n cannadev
Summary:      Libraries of Canna
Group:        Development/Libraries/C and C++
#Summary(ja): Canna 桼󥿥ե٥Υ饤֥
# %description -n cannadev -l ja
# Canna 桼󥿥ե٥Υ饤֥

%description -n cannadev
A user-interface library for use with the Canna Kana Kanji Conversion
System is provided.  With the library, programmers can easily add a
Japanese input system with unified user interface to application
programs.

Authors:
--------
    Osamu Hata <hata@d1.bs2.mt.nec.co.jp>

SuSE series: j

%prep
%setup -n Canna35b2
%patch -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1 -b .security-2002-01
perl -pi -e 's#/usr/lib/termcap#%{_libdir}/termcap#' canuum/Imakefile

%build
xmkmf 
make Makefile
make canna                 # make server, utilities and libraries
cd canuum                  
xmkmf; make Makefile        
make                       # make client
cd ..

%install
if [ -n "%{?buildroot}" ] ; then
   [ %{buildroot} != "/" ] && rm -rf %{buildroot}
fi
# add user 'wnn' (also used for Canna, not only for wnn)
if  ! grep -q '^wnn:' /etc/passwd
then
    /usr/sbin/useradd -c "Wnn System Account" -d /var/lib/wnn -u 66 wnn -s /bin/false
fi
make install DESTDIR=%{?buildroot} RPM_BUILD=TRUE
make install.man MANSUFFIX=1 LIBMANSUFFIX=3 DESTDIR=%{?buildroot}  # Japanese only!
(cd %{?buildroot}/usr/bin; strip *)
# Make links for utility programs 
# (excluded from Make process via RPM_BUILD=TRUE)
#.....................................................................
(cd %{?buildroot}/usr/bin; \
for i in cpdic lsdic mkdic mvdic rmdic syncdic addwords delwords
do
	ln -sf catdic $i
done; \
ln -sf ../bin/catdic ../sbin/cannakill)
# Install canuum
#.....................................................................
cd canuum
make install DESTDIR=%{?buildroot}
make install.man MANSUFFIX=1 LIBMANSUFFIX=3 DESTDIR=%{?buildroot}
cd ..
# gzip Japanese man pages
#.....................................................................
(cd %{?buildroot}/usr/X11R6/man/ja/man1/; gzip *)
(cd %{?buildroot}/usr/X11R6/man/ja/man3/; gzip *)
# Test for directories in preparation of boot script installation
#.................................................................
test -d $RPM_BUILD_ROOT/etc/init.d || \
   install -d $RPM_BUILD_ROOT/etc/init.d
test -d  $RPM_BUILD_ROOT/var/adm || \
   install -d $RPM_BUILD_ROOT/var/adm/fillup-templates
test -d  $RPM_BUILD_ROOT/usr/sbin || \
   install -d $RPM_BUILD_ROOT/usr/sbin
# Install boot script and rc.config entry
#.................................................................
install -m 755 $RPM_SOURCE_DIR/rccanna $RPM_BUILD_ROOT/etc/init.d/canna
ln -s ../../etc/init.d/canna $RPM_BUILD_ROOT/usr/sbin/rccanna
# Installation of English language manuals
#........................................................................
# Change Canna.conf: #undef JAPANESEMAN
#                    cannaManDir = /usr/X11R6/man
# Reconfiguration: xmkmf, make (top) Makefile, make Makefiles (in subdirs)
# Installation: make install.man MANSUFFIX=1 LIBMANSUFFIX=3 DESTDIR=%{?buildroot}
#------------------------------------------------------------------------
cd ${RPM_BUILD_DIR}/Canna35b2
sed -e 's/#define JAPANESEMAN/#undef JAPANESEMAN/
    s/\(cannaManDir = \/usr\/X11R6\/man\)\/ja/\1/' \
                                       Canna.conf > Canna.conf.sed
mv Canna.conf.sed Canna.conf
xmkmf
make Makefile
make Makefiles
make install.man MANSUFFIX=1 LIBMANSUFFIX=3 DESTDIR=%{?buildroot}
(cd %{?buildroot}/usr/X11R6/man/man1/; gzip *)
(cd %{?buildroot}/usr/X11R6/man/man3/; gzip *)
install -m 644 $RPM_SOURCE_DIR/hosts.canna %{?buildroot}/etc/hosts.canna

%pre -n canna
# add user 'wnn' (also used for Canna, not only for wnn)
if  ! grep -q '^wnn:' etc/passwd
then
  if [ -x usr/sbin/useradd ] ; then
    usr/sbin/useradd -c "Wnn System Account" -d /var/lib/wnn -u 66 wnn -s /bin/false
  fi
fi

%post
%{fillup_and_insserv -sy canna START_CANNA}

%postun
%insserv_cleanup
if [ "$1" == "0" ]; then
  rm -rf /tmp/.iroha_unix
fi

%files
%doc CHANGES.jp README{,.jp} WHATIS{,.jp} ${RPM_SOURCE_DIR}/candoc.tar.bz2
%doc INSTALL{,.jp}
%dir /var/log/canna
/etc/hosts.canna
/etc/init.d/canna
/usr/sbin/rccanna
/usr/sbin/cannakill
# more secure permissions for cannaserver and canuum
# (setuid and setgid bits were set per default).
%attr(755,-,-) /usr/sbin/cannaserver
%attr(755,-,-) /usr/bin/canuum
/usr/bin/crfreq
/usr/bin/crxdic
/usr/bin/crxgram
/usr/bin/ctow
/usr/bin/dpromdic
/usr/bin/dpxdic
/usr/bin/dicar
/usr/bin/forcpp
/usr/bin/forsort
/usr/bin/kpdic
/usr/bin/mergeword
/usr/bin/splitword
/usr/bin/wtoc
/usr/bin/mkromdic
/usr/bin/mkbindic
/usr/bin/dpbindic
/usr/bin/canlisp
/usr/bin/cannacheck
/usr/bin/cannastat
/usr/bin/cshost
/usr/bin/catdic
/usr/bin/cpdic
/usr/bin/lsdic
/usr/bin/mkdic
/usr/bin/mvdic
/usr/bin/rmdic
/usr/bin/syncdic
/usr/bin/addwords
/usr/bin/delwords
%config /var/lib/canna/default.canna
%config /var/lib/canna/engine.cf
/var/lib/canna/dic
/var/lib/canna/sample
%{_libdir}/libRKC.so.1.1
%{_libdir}/libRKC.so.1
%{_libdir}/libRKC.so
%{_libdir}/libRKC16.so.1.1
%{_libdir}/libRKC16.so.1
%{_libdir}/libRKC16.so
%{_libdir}/libcanna.so.1.1
%{_libdir}/libcanna.so.1
%{_libdir}/libcanna.so
%{_libdir}/libcanna16.so.1.1
%{_libdir}/libcanna16.so.1
%{_libdir}/libcanna16.so
/usr/X11R6/man/ja/man1/canuum.1.gz
/usr/X11R6/man/ja/man1/cannaserver.1.gz
/usr/X11R6/man/ja/man1/ctow.1.gz
/usr/X11R6/man/ja/man1/dpromdic.1.gz
/usr/X11R6/man/ja/man1/dicar.1.gz
/usr/X11R6/man/ja/man1/splitword.1.gz
/usr/X11R6/man/ja/man1/wtoc.1.gz
/usr/X11R6/man/ja/man1/mkromdic.1.gz
/usr/X11R6/man/ja/man1/mkbindic.1.gz
/usr/X11R6/man/ja/man1/dpbindic.1.gz
/usr/X11R6/man/ja/man1/cannacheck.1.gz
/usr/X11R6/man/ja/man1/cannastat.1.gz
/usr/X11R6/man/ja/man1/cshost.1.gz
/usr/X11R6/man/ja/man1/catdic.1.gz
/usr/X11R6/man/ja/man1/cpdic.1.gz
/usr/X11R6/man/ja/man1/lsdic.1.gz
/usr/X11R6/man/ja/man1/mkdic.1.gz
/usr/X11R6/man/ja/man1/mvdic.1.gz
/usr/X11R6/man/ja/man1/rmdic.1.gz
/usr/X11R6/man/ja/man1/addwords.1.gz
/usr/X11R6/man/ja/man1/delwords.1.gz
/usr/X11R6/man/ja/man1/cannakill.1.gz
/usr/X11R6/man/man1/addwords.1.gz
/usr/X11R6/man/man1/cannacheck.1.gz
/usr/X11R6/man/man1/cannakill.1.gz
/usr/X11R6/man/man1/cannaserver.1.gz
/usr/X11R6/man/man1/cannastat.1.gz
/usr/X11R6/man/man1/catdic.1.gz
/usr/X11R6/man/man1/cpdic.1.gz
/usr/X11R6/man/man1/cshost.1.gz
/usr/X11R6/man/man1/ctow.1.gz
/usr/X11R6/man/man1/delwords.1.gz
/usr/X11R6/man/man1/dicar.1.gz
/usr/X11R6/man/man1/dpbindic.1.gz
/usr/X11R6/man/man1/dpromdic.1.gz
/usr/X11R6/man/man1/lsdic.1.gz
/usr/X11R6/man/man1/mkbindic.1.gz
/usr/X11R6/man/man1/mkdic.1.gz
/usr/X11R6/man/man1/mkromdic.1.gz
/usr/X11R6/man/man1/mvdic.1.gz
/usr/X11R6/man/man1/rmdic.1.gz
/usr/X11R6/man/man1/splitword.1.gz
/usr/X11R6/man/man1/wtoc.1.gz

%files -n cannadev
/usr/X11R6/man/man3/*
%{_libdir}/libRKC.a
%{_libdir}/libRKC16.a
%{_libdir}/libcanna.a
%{_libdir}/libcanna16.a
%dir /usr/include/canna
/usr/include/canna/RK.h
/usr/include/canna/jrkanji.h
/usr/include/canna/keydef.h
/usr/include/canna/mfdef.h
/usr/X11R6/man/ja/man3/*

%changelog -n canna
* Thu Apr 08 2004 - mfabian@suse.de
- Bugzilla #37733: fix insecure use of temporary files in
  /etc/init.d/canna.
* Thu Dec 05 2002 - mfabian@suse.de
- apply security patch to fix a heap overflow vulnerability
  in the irw_through function and some other vulnerabilities.
  See also: http://canna.sourceforge.jp/sec/Canna-2002-01.txt
* Sat Jan 26 2002 - mfabian@suse.de
- use %%{_libdir}
* Thu Jan 17 2002 - ro@suse.de
- added imakefile.dif to force early include generation
* Thu Jan 10 2002 - egmont@suselinux.hu
- changed /sbin/init.d to /etc/init.d in init script comment
* Fri Dec 07 2001 - mfabian@suse.de
- get rid of START_CANNA variable in /etc/rc.config:
  use new macros fill_up_and_insserv and insserv_cleanup and
  remove testing for START_CANNA from init script.
* Mon Sep 17 2001 - mfabian@suse.de
- integrate canuum into the main package again. Splitting it
  into a sub-package is too late for SuSE 7.3.
* Sun Sep 16 2001 - mfabian@suse.de
- move canuum into an additional sub-package. Only canuum needs
  libtermcap, by moving it into a sub-package, the main canna
  packages doesn't require libtermcap anymore.
* Sat Sep 08 2001 - mfabian@suse.de
- added entry "yubin7" to the default dictionary lists
* Fri Sep 07 2001 - mfabian@suse.de
- mount more dictionaries by default, especially mount
  the supplemental cannadic dictionaries by default
- add Requires: cannadic.
* Tue May 22 2001 - mfabian@suse.de
- add a /etc/hosts.canna file to limit the access to the
  cannaserver to the local host by default.
* Thu May 03 2001 - mfabian@suse.de
- make init script comply with latest LSB spec
* Thu Mar 08 2001 - mfabian@suse.de
- improve init script (wait for server to remove socket, using
  Werner's new "usleep")
- fix %%postun, "sbin/init.d" -> "etc/init.d"
* Wed Mar 07 2001 - mfabian@suse.de
- add xf86 to "# neededforbuild"
* Fri Mar 02 2001 - mfabian@suse.de
- add multibyte patch needed for Nicolatter.
* Mon Nov 27 2000 - mfabian@suse.de
- removed socket before starting the Canna server.
  sometimes these socket remains after killing the Canna server
  which prevents a restart.
* Mon Nov 27 2000 - mfabian@suse.de
- added "route named" to "Required-Start:"
- moved init script to /etc/init.d
* Fri Nov 24 2000 - mfabian@suse.de
- fixed bug in new init script
* Thu Nov 23 2000 - mfabian@suse.de
- change to new init script mechanism:
  rewrote rccanna and use insserv to handle links to init script
* Thu Nov 16 2000 - mfabian@suse.de
- added missing newline at end of file "rc.config.canna"
* Sun Nov 12 2000 - ro@suse.de
- never redeclare/redefine bcopy/bzero
* Sat Oct 28 2000 - mfabian@suse.de
- avoided "permission denied" messages when leaving canuum
  (on exit, canuum called chown("/dev/ptyp1", 0, 0),
  chmod("/dev/ptyp1", 0666), chown("/dev/ttyp1", 0, 0)
  and chmod("/dev/ttyp1", 0666). This only worked as long as
  canuum was suid root and failed now because bk@suse.de
  removed the suid bits. But these chown and chmod don't
  seem to make sense on linux anyway, therefore I just
  removed them).
- changed Japanese locale from ja_JP.ujis to ja_JP to stop
  (this stops canuum from complaining about wrong locale during
  startup)
- add "useradd wnn" to the pre-install script, to make it build
  and install on systems where there is no user wnn yet
  (e.g. SuSE 7.0, 6.4)
- used bzip2 for sources instead of gzip.
- removed some garbage from old patches
* Fri Oct 27 2000 - bk@suse.de
- fixed startproc call(security)
- changed canna uid from bin to wnn
- removed suid bits from binaries
- fixed uninstall scripts
* Fri Sep 22 2000 - schwab@suse.de
- Fix integer/pointer clashes.
* Thu Aug 10 2000 - mfabian@suse.de
- moved Japanese manpages from subdirectories "ja_JP.ujis" to
  subdirectories "ja".
* Mon Jul 17 2000 - mfabian@suse.de
- security patch, fixes buffer overrun problem in function
  SetDicHome( client, cxnum ) in file Canna35b2/server/misc.c
* Tue Jul 11 2000 - mfabian@suse.de
- fixed links to noexisting manpages.
  Some manpages were still links to pages in section 3x:
  mfabian@gregory:/usr/X11R6/man/man3$ zcat XKanjiControl.3.gz
  .so man3/uilib.3x
  and these didn't exist, because we did put them in section 3.
